package sectr

// Based off of SDL2's Scancode; which is based off of:
// https://usb.org/sites/default/files/hut1_12.pdf
// I gutted values I would never use
QeurtyCode :: enum u32 {
	unknown         = 0,

	A               = 4,
	B               = 5,
	C               = 6,
	D               = 7,
	E               = 8,
	F               = 9,
	G               = 10,
	H               = 11,
	I               = 12,
	J               = 13,
	K               = 14,
	L               = 15,
	M               = 16,
	N               = 17,
	O               = 18,
	P               = 19,
	Q               = 20,
	R               = 21,
	S               = 22,
	T               = 23,
	U               = 24,
	V               = 25,
	W               = 26,
	X               = 27,
	Y               = 28,
	Z               = 29,

	nrow_1          = 30,
	nrow_2          = 31,
	nrow_3          = 32,
	nrow_4          = 33,
	nrow_5          = 34,
	nrow_6          = 35,
	nrow_7          = 36,
	nrow_8          = 37,
	nrow_9          = 38,
	nrow_0          = 39,

	enter           = 40,
	escape          = 41,
	backspace       = 42,
	tab             = 43,
	space           = 44,

	minus           = 45,
	equals          = 46,
	bracket_open    = 47,
	bracket_close   = 48,
	backslash       = 49,
	NONUSHASH       = 50,
	semicolon       = 51,
	apostrophe      = 52,
	grave           = 53,
	comma           = 54,
	period          = 55,
	slash           = 56,

	capslock        = 57,

	F1              = 58,
	F2              = 59,
	F3              = 60,
	F4              = 61,
	F5              = 62,
	F6              = 63,
	F7              = 64,
	F8              = 65,
	F9              = 66,
	F10             = 67,
	F11             = 68,
	F12             = 69,

	// print_screen    = 70,
	// scroll_lock     = 71,
	pause           = 72,
	insert          = 73,
	home            = 74,
	page_up         = 75,
	delete          = 76,
	end             = 77,
	page_down       = 78,
	right           = 79,
	left            = 80,
	down            = 81,
	up              = 82,

	numlock_clear   = 83,
	kpad_divide     = 84,
	kpad_multiply   = 85,
	kpad_minus      = 86,
	kpad_plus       = 87,
	kpad_enter      = 88,
	kpad_1          = 89,
	kpad_2          = 90,
	kpad_3          = 91,
	kpad_4          = 92,
	kpad_5          = 93,
	kpad_6          = 94,
	kpad_7          = 95,
	kpad_8          = 96,
	kpad_9          = 97,
	kpad_0          = 98,
	kpad_period     = 99,

	// NONUSBACKSLASH = 100,
	// OS_Compose     = 101,
	// power          = 102,
	kpad_equals     = 103,

	// F13 = 104,
	// F14 = 105,
	// F15 = 106,
	// F16 = 107,
	// F17 = 108,
	// F18 = 109,
	// F19 = 110,
	// F20 = 111,
	// F21 = 112,
	// F22 = 113,
	// F23 = 114,
	// F24 = 115,

	// execute         = 116,
	// help            = 117,
	// menu            = 118,
	// select          = 119,
	// stop            = 120,
	// again           = 121,
	// undo            = 122,
	// cut             = 123,
	// copy            = 124,
	// paste           = 125,
	// find            = 126,
	// mute            = 127,
	// volume_up       = 128,
	// volume_down     = 129,
	/* LOCKINGCAPSLOCK = 130,  */
	/* LOCKINGNUMLOCK  = 131, */
	/* LOCKINGSCROLLLOCK = 132, */
	// kpad_comma      = 133,
	// kpad_equals_AS400 = 134,

	// international_1 = 135,
	// international_2 = 136,
	// international_3 = 137,
	// international_4 = 138,
	// international_5 = 139,
	// international_6 = 140,
	// international_7 = 141,
	// international_8 = 142,
	// international_9 = 143,
	// lang_1          = 144,
	// lang_2          = 145,
	// lang_3          = 146,
	// lang_4          = 147,
	// lang_5          = 148,
	// lang_6          = 149,
	// lang_7          = 150,
	// lang_8          = 151,
	// lang_9          = 152,

	// alt_erase       = 153,
	// sysreq          = 154,
	// cancel          = 155,
	// clear           = 156,
	// prior           = 157,
	// return_2 = 158,
	// separator = 159,
	// out       = 160,
	// OPER = 161,
	// clear_again = 162,
	// CRSEL = 163,
	// EXSEL = 164,

	// KP_00 = 176,
	// KP_000 = 177,
	// THOUSANDSSEPARATOR = 178,
	// DECIMALSEPARATOR = 179,
	// CURRENCYUNIT = 180,
	// CURRENCYSUBUNIT = 181,
	// KP_LEFTPAREN = 182,
	// KP_RIGHTPAREN = 183,
	// KP_LEFTBRACE = 184,
	// KP_RIGHTBRACE = 185,
	// KP_TAB = 186,
	// KP_BACKSPACE = 187,
	// KP_A = 188,
	// KP_B = 189,
	// KP_C = 190,
	// KP_D = 191,
	// KP_E = 192,
	// KP_F = 193,
	// KP_XOR = 194,
	// KP_POWER = 195,
	// KP_PERCENT = 196,
	// KP_LESS = 197,
	// KP_GREATER = 198,
	// KP_AMPERSAND = 199,
	// KP_DBLAMPERSAND = 200,
	// KP_VERTICALBAR = 201,
	// KP_DBLVERTICALBAR = 202,
	// KP_COLON = 203,
	// KP_HASH = 204,
	// KP_SPACE = 205,
	// KP_AT = 206,
	// KP_EXCLAM = 207,
	// KP_MEMSTORE = 208,
	// KP_MEMRECALL = 209,
	// KP_MEMCLEAR = 210,
	// KP_MEMADD = 211,
	// KP_MEMSUBTRACT = 212,
	// KP_MEMMULTIPLY = 213,
	// KP_MEMDIVIDE = 214,
	// KP_PLUSMINUS = 215,
	// KP_CLEAR = 216,
	// KP_CLEARENTRY = 217,
	// KP_BINARY = 218,
	// KP_OCTAL = 219,
	// KP_DECIMAL = 220,
	// KP_HEXADECIMAL = 221,

	left_control    = 224,
	left_shift      = 225,
	left_alt        = 226,
	// LGUI            = 227,
	right_control   = 228,
	right_shift     = 229,
	right_alt       = 230,

	count = 512,
}
